import warnings
warnings.filterwarnings("ignore")

from FaithfulnessPipeline import runFaithfulnessPipeline
from utils import _load_config

experiment_dir = './outputs/LLM_QueryAndReply/'

# add '/' at end of each experiment directory
# assumes data name is the penultimate part of the experiment ID
# assumes model name is the final part of the experiment ID
experiment_IDs = [
'20230919_162557_gpt-3.5-turbo_perturb_nshot17_k4_prompt-pfpe2-topk_blood_lr/',
'20230919_164435_gpt-3.5-turbo_perturb_nshot17_k5_prompt-pfpe2-topk_adult_lr/',
'20230919_164506_gpt-3.5-turbo_perturb_nshot17_k5_prompt-pfpe2-topk_credit_lr/',
'20230919_164513_gpt-3.5-turbo_perturb_nshot17_k5_prompt-pfpe2-topk_compas_lr/',
'20230919_152946_gpt-3.5-turbo_perturb_nshot17_k4_prompt-pfpe2-topk_blood_ann_l/',
'20230919_160045_gpt-3.5-turbo_perturb_nshot17_k5_prompt-pfpe2-topk_adult_ann_l/',
'20230919_160037_gpt-3.5-turbo_perturb_nshot17_k5_prompt-pfpe2-topk_credit_ann_l/',
'20230919_154119_gpt-3.5-turbo_perturb_nshot17_k5_prompt-pfpe2-topk_compas_ann_l/',
]

calculateAUC       = True
experiment_section = "3.2"

eval_top_ks = [3] #[1, 2, 3, 4, 5]

metrics_str_per_experiment = []
for i, experiment_ID in enumerate(experiment_IDs):
    for eval_top_k in eval_top_ks:

        if 'ann_' in experiment_ID:
            model_name = 'ann_' + experiment_ID.split('_')[-1].replace('/', '')
            data_name = experiment_ID.split('_')[-3]
        else:
            data_name = experiment_ID.split('_')[-2]
            model_name = 'lr'

        if data_name == 'blood' and eval_top_k > 4:
            continue
        if data_name == 'blood':
            LLM_top_k = 4
        else:
            LLM_top_k = 5

        print('\nmax_k: ', eval_top_k)
        print('experiment_ID: ', experiment_ID)
        # Load faithfulness config
        # Set the remaining hyperparams in the faithfulness config file
        config                       = _load_config('faithfulness_config.json')
        config['data_name']          = data_name
        config['model_name']         = model_name
        print(config['data_name'], config['model_name'])
        config['eval_top_k']         = eval_top_k
        config['output_dir']         = experiment_dir + experiment_ID
        config['LLM_top_k']          = LLM_top_k
        config['calculateAUC']       = calculateAUC
        config['experiment_section'] = experiment_section

        metrics_str = runFaithfulnessPipeline(config)
        metrics_str_per_experiment.append(metrics_str)

for metrics_str in metrics_str_per_experiment:
    print(metrics_str)
